<?php

namespace App\Request;

use Symfony\Component\Validator\Constraints\Uuid;
use Symfony\Contracts\Service\Attribute\Required;

class RestaurantDetailRequest extends AbstractRequest
{
    #[Required]
    #[Uuid]
    public $restaurantId;

    protected function populate(): void
    {
        $requestUrl = $this->getRequest()->getUri();
        $index = strrpos($requestUrl, "/") + 1;

        $restaurantId = substr($requestUrl, $index);

        if (property_exists($this, "restaurantId")) {
            $this->{"restaurantId"} = $restaurantId;
        }
    }
}
