<?php

namespace App\Service;

use App\Dto\DtoInterface;
use App\Error\NotFoundError;
use App\Repository\RestaurantsRepositoryInterface;
use App\Request\AbstractRequest;

class RestaurantDetailService implements ServiceInterface
{
    public function __construct(
        private readonly RestaurantsRepositoryInterface $restaurants,
    ) {}

    /**
     * @throws NotFoundError При ненайдемом ресторане
     * @throws \JsonException При ошибке парсинга списков
     */
    public function serve(AbstractRequest $request): DtoInterface
    {
        $restaurant = $this->restaurants->find($request->restaurantId);

        if ($restaurant === null) {
            throw new NotFoundError('Restaurant');
        }

        return $restaurant->getExtendedDto();
    }
}
